Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -9,4 +9,5 @@
 
 #include "helpers.hpp"
+#include "info.hpp"
 #include "linkedcell.hpp"
 #include "log.hpp"
@@ -22,9 +23,11 @@
 /** Constructor of BoundaryPointSet.
  */
-BoundaryPointSet::BoundaryPointSet()
-{
-  LinesCount = 0;
-  Nr = -1;
-  value = 0.;
+BoundaryPointSet::BoundaryPointSet() :
+    LinesCount(0),
+    value(0.),
+    Nr(-1)
+{
+	Info FunctionInfo(__func__);
+	Log() << Verbose(1) << "Adding noname." << endl;
 };
 
@@ -32,10 +35,12 @@
  * \param *Walker TesselPoint this boundary point represents
  */
-BoundaryPointSet::BoundaryPointSet(TesselPoint * Walker)
-{
-  node = Walker;
-  LinesCount = 0;
-  Nr = Walker->nr;
-  value = 0.;
+BoundaryPointSet::BoundaryPointSet(TesselPoint * Walker) :
+  LinesCount(0),
+  node(Walker),
+  value(0.),
+  Nr(Walker->nr)
+{
+	Info FunctionInfo(__func__);
+  Log() << Verbose(1) << "Adding Node " << *Walker << endl;
 };
 
@@ -46,7 +51,8 @@
 BoundaryPointSet::~BoundaryPointSet()
 {
-  //Log() << Verbose(5) << "Erasing point nr. " << Nr << "." << endl;
+	Info FunctionInfo(__func__);
+  //Log() << Verbose(0) << "Erasing point nr. " << Nr << "." << endl;
   if (!lines.empty())
-    eLog() << Verbose(0) << "WARNING: Memory Leak! I " << *this << " am still connected to some lines." << endl;
+    eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some lines." << endl;
   node = NULL;
 };
@@ -57,5 +63,6 @@
 void BoundaryPointSet::AddLine(class BoundaryLineSet *line)
 {
-  Log() << Verbose(6) << "Adding " << *this << " to line " << *line << "."
+	Info FunctionInfo(__func__);
+  Log() << Verbose(1) << "Adding " << *this << " to line " << *line << "."
       << endl;
   if (line->endpoints[0] == this)
@@ -85,9 +92,10 @@
 /** Constructor of BoundaryLineSet.
  */
-BoundaryLineSet::BoundaryLineSet()
-{
+BoundaryLineSet::BoundaryLineSet() :
+    Nr(-1)
+{
+	Info FunctionInfo(__func__);
   for (int i = 0; i < 2; i++)
     endpoints[i] = NULL;
-  Nr = -1;
 };
 
@@ -99,4 +107,5 @@
 BoundaryLineSet::BoundaryLineSet(class BoundaryPointSet *Point[2], const int number)
 {
+	Info FunctionInfo(__func__);
   // set number
   Nr = number;
@@ -106,6 +115,8 @@
   Point[0]->AddLine(this); //Taken out, to check whether we can avoid unwanted double adding.
   Point[1]->AddLine(this); //
+  // set skipped to false
+  skipped = false;
   // clear triangles list
-  Log() << Verbose(5) << "New Line with endpoints " << *this << "." << endl;
+  Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl;
 };
 
@@ -116,4 +127,5 @@
 BoundaryLineSet::~BoundaryLineSet()
 {
+	Info FunctionInfo(__func__);
   int Numbers[2];
 
@@ -134,5 +146,5 @@
         for (LineMap::iterator Runner = erasor.first; Runner != erasor.second; Runner++)
           if ((*Runner).second == this) {
-            //Log() << Verbose(5) << "Removing Line Nr. " << Nr << " in boundary point " << *endpoints[i] << "." << endl;
+            //Log() << Verbose(0) << "Removing Line Nr. " << Nr << " in boundary point " << *endpoints[i] << "." << endl;
             endpoints[i]->lines.erase(Runner);
             break;
@@ -140,9 +152,9 @@
       } else { // there's just a single line left
         if (endpoints[i]->lines.erase(Nr)) {
-          //Log() << Verbose(5) << "Removing Line Nr. " << Nr << " in boundary point " << *endpoints[i] << "." << endl;
+          //Log() << Verbose(0) << "Removing Line Nr. " << Nr << " in boundary point " << *endpoints[i] << "." << endl;
         }
       }
       if (endpoints[i]->lines.empty()) {
-        //Log() << Verbose(5) << *endpoints[i] << " has no more lines it's attached to, erasing." << endl;
+        //Log() << Verbose(0) << *endpoints[i] << " has no more lines it's attached to, erasing." << endl;
         if (endpoints[i] != NULL) {
           delete(endpoints[i]);
@@ -153,5 +165,5 @@
   }
   if (!triangles.empty())
-    eLog() << Verbose(0) << "WARNING: Memory Leak! I " << *this << " am still connected to some triangles." << endl;
+    eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some triangles." << endl;
 };
 
@@ -161,5 +173,6 @@
 void BoundaryLineSet::AddTriangle(class BoundaryTriangleSet *triangle)
 {
-  Log() << Verbose(6) << "Add " << triangle->Nr << " to line " << *this << "." << endl;
+	Info FunctionInfo(__func__);
+  Log() << Verbose(0) << "Add " << triangle->Nr << " to line " << *this << "." << endl;
   triangles.insert(TrianglePair(triangle->Nr, triangle));
 };
@@ -171,4 +184,5 @@
 bool BoundaryLineSet::IsConnectedTo(class BoundaryLineSet *line)
 {
+	Info FunctionInfo(__func__);
   if ((endpoints[0] == line->endpoints[0]) || (endpoints[1] == line->endpoints[0]) || (endpoints[0] == line->endpoints[1]) || (endpoints[1] == line->endpoints[1]))
     return true;
@@ -185,13 +199,14 @@
 bool BoundaryLineSet::CheckConvexityCriterion()
 {
+	Info FunctionInfo(__func__);
   Vector BaseLineCenter, BaseLineNormal, BaseLine, helper[2], NormalCheck;
   // get the two triangles
   if (triangles.size() != 2) {
-    Log() << Verbose(1) << "ERROR: Baseline " << *this << " is connected to less than two triangles, Tesselation incomplete!" << endl;
+    eLog() << Verbose(0) << "Baseline " << *this << " is connected to less than two triangles, Tesselation incomplete!" << endl;
     return true;
   }
   // check normal vectors
   // have a normal vector on the base line pointing outwards
-  //Log() << Verbose(3) << "INFO: " << *this << " has vectors at " << *(endpoints[0]->node->node) << " and at " << *(endpoints[1]->node->node) << "." << endl;
+  //Log() << Verbose(0) << "INFO: " << *this << " has vectors at " << *(endpoints[0]->node->node) << " and at " << *(endpoints[1]->node->node) << "." << endl;
   BaseLineCenter.CopyVector(endpoints[0]->node->node);
   BaseLineCenter.AddVector(endpoints[1]->node->node);
@@ -199,5 +214,5 @@
   BaseLine.CopyVector(endpoints[0]->node->node);
   BaseLine.SubtractVector(endpoints[1]->node->node);
-  //Log() << Verbose(3) << "INFO: Baseline is " << BaseLine << " and its center is at " << BaseLineCenter << "." << endl;
+  //Log() << Verbose(0) << "INFO: Baseline is " << BaseLine << " and its center is at " << BaseLineCenter << "." << endl;
 
   BaseLineNormal.Zero();
@@ -207,5 +222,5 @@
   class BoundaryPointSet *node = NULL;
   for(TriangleMap::iterator runner = triangles.begin(); runner != triangles.end(); runner++) {
-    //Log() << Verbose(3) << "INFO: NormalVector of " << *(runner->second) << " is " << runner->second->NormalVector << "." << endl;
+    //Log() << Verbose(0) << "INFO: NormalVector of " << *(runner->second) << " is " << runner->second->NormalVector << "." << endl;
     NormalCheck.AddVector(&runner->second->NormalVector);
     NormalCheck.Scale(sign);
@@ -214,23 +229,22 @@
       BaseLineNormal.CopyVector(&runner->second->NormalVector);   // yes, copy second on top of first
     else {
-      Log() << Verbose(1) << "CRITICAL: Triangle " << *runner->second << " has zero normal vector!" << endl;
-      exit(255);
+      eLog() << Verbose(0) << "Triangle " << *runner->second << " has zero normal vector!" << endl;
     }
     node = runner->second->GetThirdEndpoint(this);
     if (node != NULL) {
-      //Log() << Verbose(3) << "INFO: Third node for triangle " << *(runner->second) << " is " << *node << " at " << *(node->node->node) << "." << endl;
+      //Log() << Verbose(0) << "INFO: Third node for triangle " << *(runner->second) << " is " << *node << " at " << *(node->node->node) << "." << endl;
       helper[i].CopyVector(node->node->node);
       helper[i].SubtractVector(&BaseLineCenter);
       helper[i].MakeNormalVector(&BaseLine);  // we want to compare the triangle's heights' angles!
-      //Log() << Verbose(4) << "INFO: Height vector with respect to baseline is " << helper[i] << "." << endl;
+      //Log() << Verbose(0) << "INFO: Height vector with respect to baseline is " << helper[i] << "." << endl;
       i++;
     } else {
-      //Log() << Verbose(2) << "ERROR: I cannot find third node in triangle, something's wrong." << endl;
+      eLog() << Verbose(1) << "I cannot find third node in triangle, something's wrong." << endl;
       return true;
     }
   }
-  //Log() << Verbose(3) << "INFO: BaselineNormal is " << BaseLineNormal << "." << endl;
+  //Log() << Verbose(0) << "INFO: BaselineNormal is " << BaseLineNormal << "." << endl;
   if (NormalCheck.NormSquared() < MYEPSILON) {
-    Log() << Verbose(3) << "ACCEPT: Normalvectors of both triangles are the same: convex." << endl;
+    Log() << Verbose(0) << "ACCEPT: Normalvectors of both triangles are the same: convex." << endl;
     return true;
   }
@@ -238,8 +252,8 @@
   double angle = GetAngle(helper[0], helper[1], BaseLineNormal);
   if ((angle - M_PI) > -MYEPSILON) {
-    Log() << Verbose(3) << "ACCEPT: Angle is greater than pi: convex." << endl;
+    Log() << Verbose(0) << "ACCEPT: Angle is greater than pi: convex." << endl;
     return true;
   } else {
-    Log() << Verbose(3) << "REJECT: Angle is less than pi: concave." << endl;
+    Log() << Verbose(0) << "REJECT: Angle is less than pi: concave." << endl;
     return false;
   }
@@ -252,4 +266,5 @@
 bool BoundaryLineSet::ContainsBoundaryPoint(class BoundaryPointSet *point)
 {
+	Info FunctionInfo(__func__);
   for(int i=0;i<2;i++)
     if (point == endpoints[i])
@@ -264,4 +279,5 @@
 class BoundaryPointSet *BoundaryLineSet::GetOtherEndpoint(class BoundaryPointSet *point)
 {
+	Info FunctionInfo(__func__);
   if (endpoints[0] == point)
     return endpoints[1];
@@ -286,6 +302,8 @@
 /** Constructor for BoundaryTriangleSet.
  */
-BoundaryTriangleSet::BoundaryTriangleSet()
-{
+BoundaryTriangleSet::BoundaryTriangleSet() :
+  Nr(-1)
+{
+	Info FunctionInfo(__func__);
   for (int i = 0; i < 3; i++)
     {
@@ -293,5 +311,4 @@
       lines[i] = NULL;
     }
-  Nr = -1;
 };
 
@@ -300,42 +317,35 @@
  * \param number number of triangle
  */
-BoundaryTriangleSet::BoundaryTriangleSet(class BoundaryLineSet *line[3], int number)
-{
+BoundaryTriangleSet::BoundaryTriangleSet(class BoundaryLineSet *line[3], int number) :
+  Nr(number)
+{
+	Info FunctionInfo(__func__);
   // set number
-  Nr = number;
   // set lines
-  Log() << Verbose(5) << "New triangle " << Nr << ":" << endl;
-  for (int i = 0; i < 3; i++)
-    {
-      lines[i] = line[i];
-      lines[i]->AddTriangle(this);
-    }
+  for (int i = 0; i < 3; i++) {
+    lines[i] = line[i];
+    lines[i]->AddTriangle(this);
+  }
   // get ascending order of endpoints
-  map<int, class BoundaryPointSet *> OrderMap;
+  PointMap OrderMap;
   for (int i = 0; i < 3; i++)
     // for all three lines
-    for (int j = 0; j < 2; j++)
-      { // for both endpoints
-        OrderMap.insert(pair<int, class BoundaryPointSet *> (
-            line[i]->endpoints[j]->Nr, line[i]->endpoints[j]));
-        // and we don't care whether insertion fails
-      }
+    for (int j = 0; j < 2; j++) { // for both endpoints
+      OrderMap.insert(pair<int, class BoundaryPointSet *> (
+          line[i]->endpoints[j]->Nr, line[i]->endpoints[j]));
+      // and we don't care whether insertion fails
+    }
   // set endpoints
   int Counter = 0;
-  Log() << Verbose(6) << " with end points ";
-  for (map<int, class BoundaryPointSet *>::iterator runner = OrderMap.begin(); runner
-      != OrderMap.end(); runner++)
-    {
-      endpoints[Counter] = runner->second;
-      Log() << Verbose(0) << " " << *endpoints[Counter];
-      Counter++;
-    }
-  if (Counter < 3)
-    {
-      eLog() << Verbose(0) << "ERROR! We have a triangle with only two distinct endpoints!"
-          << endl;
-      //exit(1);
-    }
-  Log() << Verbose(0) << "." << endl;
+  Log() << Verbose(0) << "New triangle " << Nr << " with end points: " << endl;
+  for (PointMap::iterator runner = OrderMap.begin(); runner != OrderMap.end(); runner++) {
+    endpoints[Counter] = runner->second;
+    Log() << Verbose(0) << " " << *endpoints[Counter] << endl;
+    Counter++;
+  }
+  if (Counter < 3) {
+    eLog() << Verbose(0) << "We have a triangle with only two distinct endpoints!" << endl;
+    performCriticalExit();
+  }
 };
 
@@ -346,11 +356,12 @@
 BoundaryTriangleSet::~BoundaryTriangleSet()
 {
+	Info FunctionInfo(__func__);
   for (int i = 0; i < 3; i++) {
     if (lines[i] != NULL) {
       if (lines[i]->triangles.erase(Nr)) {
-        //Log() << Verbose(5) << "Triangle Nr." << Nr << " erased in line " << *lines[i] << "." << endl;
+        //Log() << Verbose(0) << "Triangle Nr." << Nr << " erased in line " << *lines[i] << "." << endl;
       }
       if (lines[i]->triangles.empty()) {
-          //Log() << Verbose(5) << *lines[i] << " is no more attached to any triangle, erasing." << endl;
+          //Log() << Verbose(0) << *lines[i] << " is no more attached to any triangle, erasing." << endl;
           delete (lines[i]);
           lines[i] = NULL;
@@ -358,5 +369,5 @@
     }
   }
-  //Log() << Verbose(5) << "Erasing triangle Nr." << Nr << " itself." << endl;
+  //Log() << Verbose(0) << "Erasing triangle Nr." << Nr << " itself." << endl;
 };
 
@@ -367,4 +378,5 @@
 void BoundaryTriangleSet::GetNormalVector(Vector &OtherVector)
 {
+	Info FunctionInfo(__func__);
   // get normal vector
   NormalVector.MakeNormalVector(endpoints[0]->node->node, endpoints[1]->node->node, endpoints[2]->node->node);
@@ -373,4 +385,5 @@
   if (NormalVector.ScalarProduct(&OtherVector) > 0.)
     NormalVector.Scale(-1.);
+  Log() << Verbose(1) << "Normal Vector is " << NormalVector << "." << endl;
 };
 
@@ -389,9 +402,10 @@
 bool BoundaryTriangleSet::GetIntersectionInsideTriangle(Vector *MolCenter, Vector *x, Vector *Intersection)
 {
+	Info FunctionInfo(__func__);
   Vector CrossPoint;
   Vector helper;
 
   if (!Intersection->GetIntersectionWithPlane(&NormalVector, endpoints[0]->node->node, MolCenter, x)) {
-    Log() << Verbose(1) << "Alas! Intersection with plane failed - at least numerically - the intersection is not on the plane!" << endl;
+    eLog() << Verbose(1) << "Alas! Intersection with plane failed - at least numerically - the intersection is not on the plane!" << endl;
     return false;
   }
@@ -409,6 +423,5 @@
   } while (CrossPoint.NormSquared() < MYEPSILON);
   if (i==3) {
-    Log() << Verbose(1) << "ERROR: Could not find any cross points, something's utterly wrong here!" << endl;
-    exit(255);
+    eLog() << Verbose(0) << "Could not find any cross points, something's utterly wrong here!" << endl;
   }
   CrossPoint.SubtractVector(endpoints[i%3]->node->node);  // cross point was returned as absolute vector
@@ -429,4 +442,5 @@
 bool BoundaryTriangleSet::ContainsBoundaryLine(class BoundaryLineSet *line)
 {
+	Info FunctionInfo(__func__);
   for(int i=0;i<3;i++)
     if (line == lines[i])
@@ -441,4 +455,5 @@
 bool BoundaryTriangleSet::ContainsBoundaryPoint(class BoundaryPointSet *point)
 {
+	Info FunctionInfo(__func__);
   for(int i=0;i<3;i++)
     if (point == endpoints[i])
@@ -453,4 +468,5 @@
 bool BoundaryTriangleSet::ContainsBoundaryPoint(class TesselPoint *point)
 {
+	Info FunctionInfo(__func__);
   for(int i=0;i<3;i++)
     if (point == endpoints[i]->node)
@@ -465,4 +481,5 @@
 bool BoundaryTriangleSet::IsPresentTupel(class BoundaryPointSet *Points[3])
 {
+	Info FunctionInfo(__func__);
   return (((endpoints[0] == Points[0])
             || (endpoints[0] == Points[1])
@@ -486,4 +503,5 @@
 bool BoundaryTriangleSet::IsPresentTupel(class BoundaryTriangleSet *T)
 {
+	Info FunctionInfo(__func__);
   return (((endpoints[0] == T->endpoints[0])
             || (endpoints[0] == T->endpoints[1])
@@ -507,4 +525,5 @@
 class BoundaryPointSet *BoundaryTriangleSet::GetThirdEndpoint(class BoundaryLineSet *line)
 {
+	Info FunctionInfo(__func__);
   // sanity check
   if (!ContainsBoundaryLine(line))
@@ -523,4 +542,5 @@
 void BoundaryTriangleSet::GetCenter(Vector *center)
 {
+	Info FunctionInfo(__func__);
   center->Zero();
   for(int i=0;i<3;i++)
@@ -535,6 +555,7 @@
 ostream &operator <<(ostream &ost, const BoundaryTriangleSet &a)
 {
-  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << " at " << *a.endpoints[0]->node->node << ","
-      << a.endpoints[1]->node->Name << " at " << *a.endpoints[1]->node->node << "," << a.endpoints[2]->node->Name << " at " << *a.endpoints[2]->node->node << "]";
+  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << "," << a.endpoints[1]->node->Name << "," << a.endpoints[2]->node->Name << "]";
+//  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << " at " << *a.endpoints[0]->node->node << ","
+//      << a.endpoints[1]->node->Name << " at " << *a.endpoints[1]->node->node << "," << a.endpoints[2]->node->Name << " at " << *a.endpoints[2]->node->node << "]";
   return ost;
 };
@@ -546,4 +567,5 @@
 TesselPoint::TesselPoint()
 {
+  Info FunctionInfo(__func__);
   node = NULL;
   nr = -1;
@@ -555,4 +577,5 @@
 TesselPoint::~TesselPoint()
 {
+  Info FunctionInfo(__func__);
 };
 
@@ -569,5 +592,6 @@
 ostream & TesselPoint::operator << (ostream &ost)
 {
-  ost << "[" << (Name) << "|" << this << "]";
+	Info FunctionInfo(__func__);
+  ost << "[" << (nr) << "|" << this << "]";
   return ost;
 };
@@ -580,5 +604,5 @@
 PointCloud::PointCloud()
 {
-
+	Info FunctionInfo(__func__);
 };
 
@@ -587,5 +611,5 @@
 PointCloud::~PointCloud()
 {
-
+	Info FunctionInfo(__func__);
 };
 
@@ -594,7 +618,21 @@
 /** Constructor of class CandidateForTesselation.
  */
-CandidateForTesselation::CandidateForTesselation(TesselPoint *candidate, BoundaryLineSet* line, Vector OptCandidateCenter, Vector OtherOptCandidateCenter) {
-  point = candidate;
-  BaseLine = line;
+CandidateForTesselation::CandidateForTesselation (BoundaryLineSet* line) :
+  BaseLine(line),
+  ShortestAngle(2.*M_PI),
+  OtherShortestAngle(2.*M_PI)
+{
+	Info FunctionInfo(__func__);
+};
+
+
+/** Constructor of class CandidateForTesselation.
+ */
+CandidateForTesselation::CandidateForTesselation (TesselPoint *candidate, BoundaryLineSet* line, Vector OptCandidateCenter, Vector OtherOptCandidateCenter) :
+    BaseLine(line),
+    ShortestAngle(2.*M_PI),
+    OtherShortestAngle(2.*M_PI)
+{
+	Info FunctionInfo(__func__);
   OptCenter.CopyVector(&OptCandidateCenter);
   OtherOptCenter.CopyVector(&OtherOptCandidateCenter);
@@ -604,20 +642,44 @@
  */
 CandidateForTesselation::~CandidateForTesselation() {
-  point = NULL;
   BaseLine = NULL;
 };
 
+/** output operator for CandidateForTesselation.
+ * \param &ost output stream
+ * \param &a boundary line
+ */
+ostream & operator <<(ostream &ost, const  CandidateForTesselation &a)
+{
+  ost << "[" << a.BaseLine->Nr << "|" << a.BaseLine->endpoints[0]->node->Name << "," << a.BaseLine->endpoints[1]->node->Name << "] with ";
+  if (a.pointlist.empty())
+    ost << "no candidate.";
+  else {
+    ost << "candidate";
+    if (a.pointlist.size() != 1)
+      ost << "s ";
+    else
+      ost << " ";
+    for (TesselPointList::const_iterator Runner = a.pointlist.begin(); Runner != a.pointlist.end(); Runner++)
+      ost << *(*Runner) << " ";
+    ost << " at angle " << (a.ShortestAngle)<< ".";
+  }
+
+  return ost;
+};
+
+
 // =========================================================== class TESSELATION ===========================================
 
 /** Constructor of class Tesselation.
  */
-Tesselation::Tesselation()
-{
-  PointsOnBoundaryCount = 0;
-  LinesOnBoundaryCount = 0;
-  TrianglesOnBoundaryCount = 0;
-  InternalPointer = PointsOnBoundary.begin();
-  LastTriangle = NULL;
-  TriangleFilesWritten = 0;
+Tesselation::Tesselation() :
+  PointsOnBoundaryCount(0),
+  LinesOnBoundaryCount(0),
+  TrianglesOnBoundaryCount(0),
+  LastTriangle(NULL),
+  TriangleFilesWritten(0),
+  InternalPointer(PointsOnBoundary.begin())
+{
+	Info FunctionInfo(__func__);
 }
 ;
@@ -628,5 +690,6 @@
 Tesselation::~Tesselation()
 {
-  Log() << Verbose(1) << "Free'ing TesselStruct ... " << endl;
+	Info FunctionInfo(__func__);
+  Log() << Verbose(0) << "Free'ing TesselStruct ... " << endl;
   for (TriangleMap::iterator runner = TrianglesOnBoundary.begin(); runner != TrianglesOnBoundary.end(); runner++) {
     if (runner->second != NULL) {
@@ -634,7 +697,7 @@
       runner->second = NULL;
     } else
-      eLog() << Verbose(1) << "ERROR: The triangle " << runner->first << " has already been free'd." << endl;
-  }
-  Log() << Verbose(1) << "This envelope was written to file " << TriangleFilesWritten << " times(s)." << endl;
+      eLog() << Verbose(1) << "The triangle " << runner->first << " has already been free'd." << endl;
+  }
+  Log() << Verbose(0) << "This envelope was written to file " << TriangleFilesWritten << " times(s)." << endl;
 }
 ;
@@ -645,4 +708,5 @@
 Vector * Tesselation::GetCenter(ofstream *out) const
 {
+	Info FunctionInfo(__func__);
   Vector *Center = new Vector(0.,0.,0.);
   int num=0;
@@ -660,4 +724,5 @@
 TesselPoint * Tesselation::GetPoint() const
 {
+	Info FunctionInfo(__func__);
   return (InternalPointer->second->node);
 };
@@ -668,4 +733,5 @@
 TesselPoint * Tesselation::GetTerminalPoint() const
 {
+	Info FunctionInfo(__func__);
   PointMap::const_iterator Runner = PointsOnBoundary.end();
   Runner--;
@@ -678,4 +744,5 @@
 void Tesselation::GoToNext() const
 {
+	Info FunctionInfo(__func__);
   if (InternalPointer != PointsOnBoundary.end())
     InternalPointer++;
@@ -687,4 +754,5 @@
 void Tesselation::GoToPrevious() const
 {
+	Info FunctionInfo(__func__);
   if (InternalPointer != PointsOnBoundary.begin())
     InternalPointer--;
@@ -696,4 +764,5 @@
 void Tesselation::GoToFirst() const
 {
+	Info FunctionInfo(__func__);
   InternalPointer = PointsOnBoundary.begin();
 };
@@ -704,4 +773,5 @@
 void Tesselation::GoToLast() const
 {
+	Info FunctionInfo(__func__);
   InternalPointer = PointsOnBoundary.end();
   InternalPointer--;
@@ -713,4 +783,5 @@
 bool Tesselation::IsEmpty() const
 {
+	Info FunctionInfo(__func__);
   return (PointsOnBoundary.empty());
 };
@@ -721,4 +792,5 @@
 bool Tesselation::IsEnd() const
 {
+	Info FunctionInfo(__func__);
   return (InternalPointer == PointsOnBoundary.end());
 };
@@ -733,4 +805,5 @@
 Tesselation::GuessStartingTriangle()
 {
+	Info FunctionInfo(__func__);
   // 4b. create a starting triangle
   // 4b1. create all distances
@@ -779,7 +852,5 @@
           baseline->second.first->second->node->node,
           baseline->second.second->second->node->node);
-      Log() << Verbose(2) << "Plane vector of candidate triangle is ";
-      PlaneVector.Output();
-      Log() << Verbose(0) << endl;
+      Log() << Verbose(2) << "Plane vector of candidate triangle is " << PlaneVector << endl;
       // 4. loop over all points
       double sign = 0.;
@@ -797,6 +868,5 @@
           if (fabs(distance) < 1e-4) // we need to have a small epsilon around 0 which is still ok
             continue;
-          Log() << Verbose(3) << "Projection of " << checker->second->node->Name
-              << " yields distance of " << distance << "." << endl;
+          Log() << Verbose(2) << "Projection of " << checker->second->node->Name << " yields distance of " << distance << "." << endl;
           tmp = distance / fabs(distance);
           // 4b. Any have different sign to than before? (i.e. would lie outside convex hull with this starting triangle)
@@ -851,5 +921,5 @@
       if (checker == PointsOnBoundary.end())
         {
-          Log() << Verbose(0) << "Looks like we have a candidate!" << endl;
+          Log() << Verbose(2) << "Looks like we have a candidate!" << endl;
           break;
         }
@@ -881,6 +951,5 @@
   else
     {
-      Log() << Verbose(1) << "No starting triangle found." << endl;
-      exit(255);
+      eLog() << Verbose(0) << "No starting triangle found." << endl;
     }
 }
@@ -902,4 +971,5 @@
 void Tesselation::TesselateOnBoundary(const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   bool flag;
   PointMap::iterator winner;
@@ -920,9 +990,9 @@
         // get peak point with respect to this base line's only triangle
         BTS = baseline->second->triangles.begin()->second; // there is only one triangle so far
-        Log() << Verbose(2) << "Current baseline is between " << *(baseline->second) << "." << endl;
+        Log() << Verbose(0) << "Current baseline is between " << *(baseline->second) << "." << endl;
         for (int i = 0; i < 3; i++)
           if ((BTS->endpoints[i] != baseline->second->endpoints[0]) && (BTS->endpoints[i] != baseline->second->endpoints[1]))
             peak = BTS->endpoints[i];
-        Log() << Verbose(3) << " and has peak " << *peak << "." << endl;
+        Log() << Verbose(1) << " and has peak " << *peak << "." << endl;
 
         // prepare some auxiliary vectors
@@ -939,5 +1009,5 @@
           CenterVector.AddVector(BTS->endpoints[i]->node->node);
         CenterVector.Scale(1. / 3.);
-        Log() << Verbose(4) << "CenterVector of base triangle is " << CenterVector << endl;
+        Log() << Verbose(2) << "CenterVector of base triangle is " << CenterVector << endl;
 
         // normal vector of triangle
@@ -946,5 +1016,5 @@
         BTS->GetNormalVector(NormalVector);
         NormalVector.CopyVector(&BTS->NormalVector);
-        Log() << Verbose(4) << "NormalVector of base triangle is " << NormalVector << endl;
+        Log() << Verbose(2) << "NormalVector of base triangle is " << NormalVector << endl;
 
         // vector in propagation direction (out of triangle)
@@ -953,8 +1023,8 @@
         TempVector.CopyVector(&CenterVector);
         TempVector.SubtractVector(baseline->second->endpoints[0]->node->node); // TempVector is vector on triangle plane pointing from one baseline egde towards center!
-        //Log() << Verbose(2) << "Projection of propagation onto temp: " << PropagationVector.Projection(&TempVector) << "." << endl;
+        //Log() << Verbose(0) << "Projection of propagation onto temp: " << PropagationVector.Projection(&TempVector) << "." << endl;
         if (PropagationVector.ScalarProduct(&TempVector) > 0) // make sure normal propagation vector points outward from baseline
           PropagationVector.Scale(-1.);
-        Log() << Verbose(4) << "PropagationVector of base triangle is " << PropagationVector << endl;
+        Log() << Verbose(2) << "PropagationVector of base triangle is " << PropagationVector << endl;
         winner = PointsOnBoundary.end();
 
@@ -962,5 +1032,5 @@
         for (PointMap::iterator target = PointsOnBoundary.begin(); target != PointsOnBoundary.end(); target++) {
           if ((target->second != baseline->second->endpoints[0]) && (target->second != baseline->second->endpoints[1])) { // don't take the same endpoints
-            Log() << Verbose(3) << "Target point is " << *(target->second) << ":" << endl;
+            Log() << Verbose(1) << "Target point is " << *(target->second) << ":" << endl;
 
             // first check direction, so that triangles don't intersect
@@ -969,10 +1039,10 @@
             VirtualNormalVector.ProjectOntoPlane(&NormalVector);
             TempAngle = VirtualNormalVector.Angle(&PropagationVector);
-            Log() << Verbose(4) << "VirtualNormalVector is " << VirtualNormalVector << " and PropagationVector is " << PropagationVector << "." << endl;
+            Log() << Verbose(2) << "VirtualNormalVector is " << VirtualNormalVector << " and PropagationVector is " << PropagationVector << "." << endl;
             if (TempAngle > (M_PI/2.)) { // no bends bigger than Pi/2 (90 degrees)
-              Log() << Verbose(4) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", bad direction!" << endl;
+              Log() << Verbose(2) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", bad direction!" << endl;
               continue;
             } else
-              Log() << Verbose(4) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", good direction!" << endl;
+              Log() << Verbose(2) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", good direction!" << endl;
 
             // check first and second endpoint (if any connecting line goes to target has at least not more than 1 triangle)
@@ -980,9 +1050,9 @@
             LineChecker[1] = baseline->second->endpoints[1]->lines.find(target->first);
             if (((LineChecker[0] != baseline->second->endpoints[0]->lines.end()) && (LineChecker[0]->second->triangles.size() == 2))) {
-              Log() << Verbose(4) << *(baseline->second->endpoints[0]) << " has line " << *(LineChecker[0]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[0]->second->triangles.size() << " triangles." << endl;
+              Log() << Verbose(2) << *(baseline->second->endpoints[0]) << " has line " << *(LineChecker[0]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[0]->second->triangles.size() << " triangles." << endl;
               continue;
             }
             if (((LineChecker[1] != baseline->second->endpoints[1]->lines.end()) && (LineChecker[1]->second->triangles.size() == 2))) {
-              Log() << Verbose(4) << *(baseline->second->endpoints[1]) << " has line " << *(LineChecker[1]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[1]->second->triangles.size() << " triangles." << endl;
+              Log() << Verbose(2) << *(baseline->second->endpoints[1]) << " has line " << *(LineChecker[1]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[1]->second->triangles.size() << " triangles." << endl;
               continue;
             }
@@ -1001,5 +1071,5 @@
             helper.ProjectOntoPlane(&TempVector);
             if (fabs(helper.NormSquared()) < MYEPSILON) {
-              Log() << Verbose(4) << "Chosen set of vectors is linear dependent." << endl;
+              Log() << Verbose(2) << "Chosen set of vectors is linear dependent." << endl;
               continue;
             }
@@ -1018,9 +1088,9 @@
             // calculate angle
             TempAngle = NormalVector.Angle(&VirtualNormalVector);
-            Log() << Verbose(4) << "NormalVector is " << VirtualNormalVector << " and the angle is " << TempAngle << "." << endl;
+            Log() << Verbose(2) << "NormalVector is " << VirtualNormalVector << " and the angle is " << TempAngle << "." << endl;
             if ((SmallestAngle - TempAngle) > MYEPSILON) { // set to new possible winner
               SmallestAngle = TempAngle;
               winner = target;
-              Log() << Verbose(4) << "New winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl;
+              Log() << Verbose(2) << "New winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl;
             } else if (fabs(SmallestAngle - TempAngle) < MYEPSILON) { // check the angle to propagation, both possible targets are in one plane! (their normals have same angle)
               // hence, check the angles to some normal direction from our base line but in this common plane of both targets...
